abuild.in 33.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo_base=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24
apk_opt_wait="--wait 30"
25

Natanael Copa's avatar
Natanael Copa committed
26
# read config
Natanael Copa's avatar
Natanael Copa committed
27
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
28 29
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

30
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
31 32 33 34 35 36
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
37 38 39 40 41 42 43 44 45 46 47 48 49 50
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
75 76

	
Linux User's avatar
Linux User committed
77
set_xterm_title() {
78
	if [ "$TERM" = xterm ] && [ -n "$USE_COLORS" ]; then
79
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
80 81 82 83 84
	fi
} 

cleanup() {
	set_xterm_title ""
85
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
86
		$SUDO $APK del $apk_opt_wait $uninstall_after
87
	fi
Linux User's avatar
Linux User committed
88 89
}

Natanael Copa's avatar
Natanael Copa committed
90
die() {
Linux User's avatar
Linux User committed
91
	error "$@"
Linux User's avatar
Linux User committed
92
	cleanup
Natanael Copa's avatar
Natanael Copa committed
93 94 95
	exit 1
}

96 97
# check if apkbuild is basicly sane
sanitycheck() {
98
	local i suggestion
99
	msg "Checking sanity of $APKBUILD..."
100 101 102
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
103
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
104
		$APK version --check -q "$pkgver" ||\
105 106
			die "$pkgver is not a valid version"
	fi
107
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
108 109 110 111
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

112 113 114 115 116 117 118 119 120 121
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
122 123 124 125 126 127 128
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

129 130
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
131 132 133 134
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
135
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
136 137 138
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
139 140
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
141

142 143
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
144
			source_has $i || die "$i exists in md5sums but is missing in source"
145 146
		done
	fi
147

148 149 150
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
151 152

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
153 154

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
155 156 157 158
	return 0
}

md5check() {
159
	local dummy f endreturnval originalparams origin file
160 161 162
	if [ -z "$source" ]; then
		return 0
	fi
163
	if [ -z "$md5sums" ]; then
164
		die "Use 'abuild checksum' to generate/update the checksum(s)"
165
	fi
166 167 168
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
169
	fetch || return 1
170
	msg "Checking md5sums..."
Natanael Copa's avatar
Natanael Copa committed
171
	cd "$srcdir" || return 1
172 173 174 175 176 177 178 179
	IFS=$'\n'
	endreturnval=0
	originalparams=$@
	set -- $source
	for src in $md5sums; do
		origin=$1; shift
		echo "$src" | md5sum -c
		if [ $? -ne 0 ]; then
180
			endreturnval=1
181 182 183 184 185 186 187 188 189 190 191
			is_remote $origin || continue
			echo "Because the remote file above failed the md5sum check it will be deleted."
			echo "Rebuilding will cause it to re-download which in some cases may fix the problem."
			file=`echo "$src" | sed 's/.*[ \t\n]\(.*\)/\1/'`
			echo "Deleting: $file"
			rm $file
		fi
	done
	unset IFS
	set -- $originalparams
	return $endreturnval
Natanael Copa's avatar
Natanael Copa committed
192 193
}

194 195
# verify upstream sources
sourcecheck() {
196 197 198 199 200 201 202 203 204 205
	local uri
	for uri in $source; do
		is_remote $uri || continue
		case "$uri" in
		saveas-*://*)
			uri=${uri#saveas-}
			uri=${uri%/*}
			;;
		esac
		wget -q -s "$uri" || return 1
206
	done
207
	return 0
208
}
209

Natanael Copa's avatar
Natanael Copa committed
210 211
uri_fetch() {
	local uri="$1"
212
	local d="${uri##*/}"	# $(basename $uri)
213 214 215 216
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

217 218 219 220 221
	# fix saveas-*://* URIs
	case "$uri" in
		# remove 'saveas-' from beginning and
		# '/filename' from end of URI
		saveas-*://*) uri="${uri:7:$(expr ${#uri} - 7 - ${#d} - 1)}";;
222
	esac
223 224 225 226 227

	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
228
	
Natanael Copa's avatar
Natanael Copa committed
229
	mkdir -p "$SRCDEST"
230 231 232
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
233
	fi
Linux User's avatar
Linux User committed
234
	msg "Fetching $uri"
235 236
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
237 238
}

239 240
is_remote() {
	case "$1" in
241
		http://*|ftp://*|https://*|saveas-*://*)
242 243 244 245 246
			return 0;;
	esac
	return 1
}

247 248 249 250 251
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
252 253 254 255 256
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
257 258 259 260
	fi
	uri_fetch "$uri"
}

261
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
262 263
	local s
	mkdir -p "$srcdir"
264 265
	for s in $source; do
		if is_remote "$s"; then
266
			uri_fetch_mirror "$s" || return 1
267 268 269 270
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
271 272 273
	done
}

274 275 276 277
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
278 279 280 281 282 283 284 285 286 287 288 289 290 291 292
# verify that all init.d scripts are openrc runscripts
initdcheck() {
	local i
	for i in $source; do
		case $i in
		*.initd)
			head -n 1 "$srcdir"/$i | grep -q '/sbin/runscript' \
				&& continue
			error "$i is not an openrc #!/sbin/runscript"
			return 1
			;;
		esac
	done			
}

Natanael Copa's avatar
Natanael Copa committed
293
# unpack the sources
294
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
295
	local u
296 297
	if [ -z "$force" ]; then
		md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
298
		initdcheck || return 1
299
	fi
Natanael Copa's avatar
Natanael Copa committed
300 301 302 303
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
304
			*.tar.gz|*.tgz)
305
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
306 307
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
308
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
309
				tar -C "$srcdir" -jxf "$s" || return 1;;
310 311 312 313
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
314 315 316
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
317 318 319
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
320 321 322 323
		esac
	done
}

324 325 326 327
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
328 329
# cleanup source and package dir
clean() {
330
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
331
	rm -rf "$srcdir"
332
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
333 334 335 336 337 338
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
339 340 341 342
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
343 344 345
	done
}

346 347 348 349 350 351 352 353 354 355
listpkgnames() {
	local i
	for i in $pkgname $subpackages; do
		echo ${i%:*}
	done
	for i in $linguas; do
		echo $pkgname-lang-$i
	done
}

Natanael Copa's avatar
Natanael Copa committed
356 357
cleanpkg() {
	local i
358
	getpkgver || return 1
359
	msg "Cleaning built packages..."
360
	for i in $(listpkgnames); do
361 362
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
363
			"$abuildrepo"/$p.apk "$abuildrepo"/*/$p.apk
Natanael Copa's avatar
Natanael Copa committed
364
	done
365
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
366 367
}

368 369 370
# clean all packages except current
cleanoldpkg() {
	local i j
371
	getpkgver || return 1
372
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
373
	for i in $(listpkgnames); do
374 375 376 377 378
		local pn=${i%:*}
		for j in "$PKGDEST"/$pn-[0-9]*.apk ; do
			[ "$j" = "$PKGDEST/$pn-$pkgver-r$pkgrel.apk" ] \
				&& continue
			rm -f "$j" "$abuildrepo"/*/${j##*/}
379 380 381 382
		done
	done
	return 0
}
383 384 385 386 387

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
388
			local gopt=
389
			msg "Creating user $i"
390 391 392 393
			if getent group $i >/dev/null; then
				gopt="-G $i"
			fi
			$SUDO adduser -D -H $gopt $i || return 1
394 395 396 397 398 399 400 401 402 403 404
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
405 406
runpart() {
	local part=$1
407
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
408 409 410 411
	$part || die "$part failed"
}

# override those in your build script
412 413 414 415 416 417 418 419
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
420 421 422 423
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
424
build() {
425
	:
Natanael Copa's avatar
Natanael Copa committed
426 427
}

428 429 430
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
Natanael Copa's avatar
Natanael Copa committed
431
	mkdir -p "$PKGDEST"
432 433 434
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

435 436 437 438 439 440 441 442 443
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

444
prepare_subpackages() {
Natanael Copa's avatar
Natanael Copa committed
445 446
	local i
	cd "$startdir"
447
	for i in $subpackages; do
448 449
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
450
		msg "Running split function $func..."
451
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
452
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
453 454 455
	done
}

456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477
lang_subpkg() {
	if [ -z "$lang" ]; then
		error "lang is not set"
		return 1
	fi
	arch="noarch"
	install_if="$pkgname=$pkgver-r$pkgrel lang-$lang"
	mkdir -p "$subpkgdir"/usr/share/locale
	mv "$pkgdir"/usr/share/locale/$lang* \
		"$subpkgdir"/usr/share/locale/ \
		|| return 1
}

prepare_language_packs() {
	for lang in $linguas; do
		lang="$lang" \
		subpkgname="$pkgname-lang-$lang" \
		subpkgdir="$pkgbasedir"/$subpkgname \
			$0 lang_subpkg prepare_package || return 1
	done
}

478 479 480 481 482 483 484 485 486 487 488 489
# echo '-dirty' if git is not clean
git_dirty() {
	if [ $(git status -s "$startdir" | wc -l) -ne 0 ]; then
		echo "-dirty"
	fi
}

# echo last commit hash id
git_last_commit() {
	git log --format=oneline -n 1 "$startdir" | awk '{print $1}'
}

490 491 492 493 494 495
get_maintainer() {
	if [ -z "$maintainer" ]; then
		maintainer=$(awk -F': ' '/\# *Maintainer/ {print $2}' "$APKBUILD")
	fi
}

496
prepare_metafiles() {
497
	getpkgver || return 1
498 499
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
500
	local dir=${subpkgdir:-$pkgdir}
501
	local pkg="$name-$pkgver-r$pkgrel.apk"
502
	local pkginfo="$controldir"/.PKGINFO
503
	local sub
Natanael Copa's avatar
Natanael Copa committed
504 505 506
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
507
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
508 509
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')
Natanael Copa's avatar
Natanael Copa committed
510
	local parch="$CARCH"
511 512 513 514 515

	# we need to wait with setting noarch til our build infra can handle it
#	if [ "$arch" = "noarch" ]; then
#		parch="noarch"
#	fi
Natanael Copa's avatar
Natanael Copa committed
516

517
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
518
	if [ -n "$FAKEROOTKEY" ]; then
519
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
520
	fi
521 522
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
523
pkgname = $name
524
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
525 526 527 528 529
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
Natanael Copa's avatar
Natanael Copa committed
530
arch = $parch
531
origin = $pkgname
Natanael Copa's avatar
Natanael Copa committed
532
EOF
533 534
	local i deps
	deps="$depends"
535
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
536 537
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
538 539 540 541 542
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
543 544
	fi
	
545 546 547 548 549 550 551 552 553 554
	local last_commit="$(git_last_commit)$(git_dirty)"
	if [ -n "$last_commit" ]; then
		echo "commit = $last_commit" >> "$pkginfo"
	fi

	get_maintainer
	if [ -n "$maintainer" ]; then
		echo "maintainer = $maintainer" >> "$pkginfo"
	fi

Natanael Copa's avatar
Natanael Copa committed
555
	for i in $license; do
556
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
557 558
	done
	for i in $replaces; do
559
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
560
	done
561
	for i in $deps; do
562
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
563 564
	done
	for i in $conflicts; do
565
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
566 567
	done
	for i in $provides; do
568
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
569
	done
Natanael Copa's avatar
Natanael Copa committed
570 571 572
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
573 574 575
	if [ -n "$install_if" ]; then
		echo "install_if = $(echo $install_if)" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
576 577

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
578
	for i in $install ${triggers%%:*}; do
579 580
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
581
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
582 583
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
584
			*) 	error "$script: Invalid install/trigger script"
585 586 587
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
588
		cp "$startdir/$i" "$controldir/$script" || return 1
589
		chmod +x "$controldir/$script"
590 591
		metafiles="$metafiles $script"
	done
592
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
593
}
594

595 596
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
597
	[ "$arch" = "noarch" ] && return 0
598
	options_has "!tracedeps" && return 0
599
	# lets tell all the .so files this package provides in .provides-so
600 601
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
602 603 604 605 606
	# lets tell all the places we should look for .so files - all rpaths
	scanelf -q -Rr "$dir" | sed -e 's/[[:space:]].*//' -e 's/:/\n/' \
		| sort | uniq \
		>"$controldir"/.rpaths
	# now find the so dependencies
607
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
608 609 610
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
611 612
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
613
	done
Natanael Copa's avatar
Natanael Copa committed
614 615
}

616 617 618 619 620 621 622 623 624 625 626 627
# check if dir has arch specific binaries
dir_has_arch_binaries() {
	local dir="$1"
	# if scanelf returns something, then we have binaries
	[ -n "$(scanelf -R "$dir" | head -n 1)" ] && return 0

	# look for static *.a
	[ -n "$(find "$dir" -type f -name '*.a' | head -n 1)" ] && return 0

	return 1
}

628 629 630 631 632
# returns true if this is the -dev package
is_dev_pkg() {
	test "${subpkgname%-dev}" != "$subpkgname"
}

633 634 635 636 637 638 639
# check that noarch is set if needed
archcheck() {
	options_has "!archcheck" && return 0
	if dir_has_arch_binaries "${subpkgdir:-$pkgdir}"; then
		[ "$arch" != "noarch" ] && return 0
		error "Arch specific binaries found so arch must not be set to \"noarch\""
		return 1
640 641 642
	elif [ "$arch" != "noarch" ] && ! is_dev_pkg; then
		# we dont want -dev package go to noarch
		warning "No arch specific binaries found so arch should probably be set to \"noarch\""
643 644 645 646
	fi
	return 0
}

647
prepare_package() {
648
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
649
	stripbin
650 651
	prepare_metafiles && prepare_tracedeps || return 1
	archcheck	
652 653 654 655 656 657 658 659
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682
# find real path to so files
real_so_path() {
	local so="$1"
	shift
	while [ $# -gt 0 ]; do
		[ -e "$1"/$so ] && realpath "$1/$so" && return 0
		shift
	done
	error "$so: path not found"
	return 1
}

# search rpaths and /usr/lib /lib for given so files
find_so_files() {
	local rpaths=$(cat "$1")
	shift
	while [ $# -gt 0 ]; do
		real_so_path "$1" /usr/lib /lib $rpaths || return 1
		shift
	done
	return 0
}

683 684 685
trace_apk_deps() {
	local name="$1"
	local dir="$2"
686
	local i= j= found= autodeps= deppkgs= missing= so_paths= self_provided=
687
	msg "Tracing dependencies for $name..."
688 689 690
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
691
		msg "  added pkgconfig (found /usr/lib/pkgconfig)"
692 693 694 695
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
696
	if [ -f "$dir"/.needs-so ] && grep -q -w '^libpthread.so.*' "$dir"/.needs-so \
697 698
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
699
		msg "  added libgcc (due to libpthread)"
700
	fi
701
	[ -f "$dir"/.needs-so ] && for i in $(cat "$dir"/.needs-so); do
702
		found=
703
		# first check if its provide by same apkbuild
704
		for j in "$dir"/../.control.*/.provides-so; do
705
			grep -w "$i" "$j" >/dev/null || continue
706
			found=${j%/.provides-so}
707
			found=${found##*/.control.}
708
			break
709
		done
710 711 712 713 714 715
		if [ -n "$found" ]; then
			if ! list_has "$found" $self_provided; then
				self_provided="$self_provided $found"
			fi
		else
			missing="$missing $i"
716
		fi
717 718 719
	done

	# find all packages that holds the so files
720 721 722 723 724
	if [ -f "$dir"/.rpaths ]; then
		so_files=$(find_so_files "$dir"/.rpaths $missing) || return 1
		deppkgs=$($APK info -q -W $so_files) || return 1
	fi

725
	for found in $self_provided $deppkgs; do
726
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
727 728 729
			warning "You can remove '$found' from depends"
			continue
		fi
730 731
		if [ "$found" != "$name" ] && ! list_has "$found" $autodeps; then
			autodeps="$autodeps $found"
732
			msg "  added $found"
733
		fi
734
	done
735

736 737 738 739 740 741 742
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

743 744
create_apks() {
	local file
745
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
746
	mkdir -p "$PKGDEST"
747
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
748 749 750
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
751
		local apk=$name-$ver.apk
752
		local datadir="$pkgbasedir"/$name
753 754

		trace_apk_deps "$name" "$dir" || return 1
755
		msg "Creating $apk..."
756
		(
757 758
		cd "$datadir"
		# data.tar.gz
759 760 761 762 763 764
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
765 766 767 768 769 770

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
771
		cd "$dir"
772 773
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
774
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
775

776 777 778
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
779 780 781
	done
}

782
clean_abuildrepo() {
783
	local apk
784 785 786
	cd "$abuildrepo" || return 1
	
	# remove compat symlink
787
	for d in "$abuildrepo/$CARCH"; do
788 789
		[ -L "$d" ] && rm "$d"
	done
790

791 792
	# remove broken links from abuildrepo
	for apk in *.apk */*.apk; do
793 794 795 796
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done
797
}
798

799
mklinks_abuildrepo() {
800 801
	local apk
	mkdir -p "$abuildrepo"/$CARCH
802
	cd "$abuildrepo" || return 1
803
	# create links for this package
804
	for apk in $(listpkg); do
805
		[ -f "$PKGDEST"/$apk ] || continue
806
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$CARCH/$apk
807
	done
808 809 810 811 812 813 814 815 816 817 818 819 820 821
}

update_abuildrepo() {
	local d apk
	if ! apk_up2date || [ -n "$force" ]; then
		sanitycheck && builddeps && clean && fetch && unpack \
			&& prepare && mkusers && rootpkg || return 1
	fi

	clean_abuildrepo
	mklinks_abuildrepo

	cd "$abuildrepo"
	local index=$CARCH/APKINDEX.tar.gz
822

823
	msg "Updating the cached abuild repository index..."
824 825
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
826 827
	if [ -f "$index" ]; then
		oldindex="--index $index"
828
	fi
829
	$APK index --quiet $oldindex --output "$index".unsigned \
830
		--description "$repo $(cd $startdir && git describe)" \
831 832
		--rewrite-arch $CARCH \
		$CARCH/*.apk || exit 1
833
	msg "Signing the index..."
834 835 836
	abuild-sign -q "$index".unsigned || exit 1
	mv "$index".unsigned "$index"
	chmod 644 "$index"
837 838
}

839
# predefined splitfunc doc
840
default_doc() {
841
	depends="$depends_doc"
842
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
843
	triggers="$triggers_doc"
844
	pkgdesc="$pkgdesc (documentation)"
845
	arch=${arch_doc:-"noarch"}
846

Natanael Copa's avatar
Natanael Copa committed
847
	local i
848
	for i in doc man info html sgml licenses gtk-doc; do
849 850 851
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
852 853
		fi
	done
854 855 856
	
	rm -f "$subpkgdir/usr/share/info/dir"

857 858 859
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
860 861 862 863

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
864
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
865 866 867
	return 0
}

868 869 870 871
doc() {
	default_doc
}

872
# predefined splitfunc mod
873
default_mod() {
874
	depends="$kernel $depends_mod"
875
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
876
	for i in firmware modules; do
877 878 879
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
880
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
881 882 883 884
		fi
	done
}

885 886 887 888
mod() {
	default_mod
}

889
# predefined splitfunc dev
890
default_dev() {
891
	local i= j=
892
	depends="$pkgname $depends_dev"
893
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
894
	triggers="$triggers_dev"
895 896
	pkgdesc="$pkgdesc (development files)"

897 898 899 900
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
901
	cd "$pkgdir" || return 0
902 903
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
904
			usr/share/vala/vapi usr/share/gir-[0-9]*\
905 906 907
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
908 909
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
910
			mkdir -p "$d"
911
			mv "$pkgdir/$i" "$d"
912
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
913 914
		fi
	done
915 916 917 918 919 920 921
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
922
	return 0
Natanael Copa's avatar
Natanael Copa committed
923 924
}

925 926 927 928
dev() {
	default_dev
}

929 930 931 932
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

933 934 935 936 937 938 939 940
do_fakeroot() {
	if [ -n "$FAKEROOT" ]; then
		$FAKEROOT -- "$@"
	else
		"$@"
	fi
}

Natanael Copa's avatar
Natanael Copa committed
941 942
# build and package in fakeroot
rootpkg() {
943 944 945 946
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
947
		do_build=package
948
	fi
Natanael Copa's avatar
Natanael Copa committed
949
	cd "$startdir"
950
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
951
	do_fakeroot "$abuild_path" $color_opt $do_build \
952
		prepare_subpackages \
953
		prepare_language_packs \
954
		prepare_package \
955
		create_apks
Natanael Copa's avatar
Natanael Copa committed
956 957 958
}

srcpkg() {
959
	getpkgver || return 1
960
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
961
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
962 963 964 965 966
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
967
	msg "Creating source package $p.src.tar.gz..."
968
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
969 970
}

Natanael Copa's avatar
Natanael Copa committed
971 972
# return true if arch is supported or noarch
check_arch() {
Natanael Copa's avatar
Natanael Copa committed
973
	list_has $CARCH $arch || [ "$arch" = "noarch" ] || [ "$arch" = "all" ]
Natanael Copa's avatar
Natanael Copa committed
974 975
}

976
# check if package is up to date
977
apk_up2date() {
978
	getpkgver || return 1
979
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
980
	local i s
Natanael Copa's avatar
Natanael Copa committed
981
	cd "$startdir"
982 983 984 985 986
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

987
	for i in $source APKBUILD; do
988 989 990 991 992 993
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
994 995 996 997 998 999 1000
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

1001
abuildindex_up2date() {
1002
	local i
1003
	getpkgver || return 1
1004 1005 1006 1007 1008 1009 1010
	local dir="$abuildrepo"/$CARCH
	local apk="${pkgname%:*}-$pkgver-r$pkgrel.apk"
	local idx="$dir"/APKINDEX.tar.gz
	local file="$dir"/$apk

	# check if index is missing
	[ -f "$idx" ] || return 1
1011
			
1012 1013 1014 1015 1016
	# if link or file is missing, then we need update abuildrepo index
	[ -f "$file" ] || return 1

	# if file exists and is newer than index, then we need update index
	[ "$file" -nt "$idx" ] && return 1
1017
		
1018 1019 1020 1021
	return 0
}

up2date() {
Natanael Copa's avatar
Natanael Copa committed
1022
	check_arch || return 0
1023 1024 1025 1026 1027 1028 1029
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
1030 1031
}

1032 1033 1034 1035 1036 1037 1038
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
1039 1040
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
1041 1042 1043 1044
		pkgname=
		subpackages=
		depends=
		makedepends=
1045
		. $i
1046
		dir=${i%/APKBUILD}
1047
		deps=
1048
		# filter out conflicts from deps and version info
1049 1050 1051 1052
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
1053
			deps="$deps ${j%%[<>=]*}"
1054
		done
1055
		for j in $pkgname $subpackages; do
1056
			echo "o ${j%%:*} $dir"
1057
			set -- $deps
1058 1059 1060 1061 1062 1063 1064
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
1065 1066
		done
	done
1067
	)
1068 1069
}

1070
deptrace() {
1071 1072 1073
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
1074
		deps="$deps ${i%%[<>=]*}"
1075
	done
1076
	[ -z "$deps" ] && return 0
1077 1078 1079
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
1080
			$APK info -q | sort |  sed 's/^/i /'
1081
		fi
1082
	) | awk -v pkgs="$deps" '
1083 1084 1085 1086 1087 1088 1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100 1101 1102 1103 1104 1105 1106 1107

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
1108
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
1109
	local filtered_deps= conflicts=
1110
	[ -n "$nodeps" ] && return 0
1111
	msg "Analyzing dependencies..."
1112

1113 1114 1115
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
1116
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
1117 1118
	done

1119
	installed_deps=$($APK info -e $deps)
1120
	# find which deps are missing
1121
	for i in $deps; do
1122
		if [ "${i#\!}" != "$i" ]; then
1123
			$APK info -q -e "${i#\!}" \
1124
				&& conflicts="$conflicts ${i#\!}"
1125
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
1126 1127 1128
			missing="$missing $i"
		fi
	done
1129
	
1130
	if [ -n "$conflicts" ]; then
1131 1132
		error "Conflicting package(s) installed:$conflicts"
		return 1
1133 1134 1135 1136 1137 1138 1139 1140
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi